/**
 * @license
 *-------------------------------------------------------------------------------------------
 * Copyright © 2025 Progress Software Corporation. All rights reserved.
 * Licensed under commercial license. See LICENSE.md in the package root for more information
 *-------------------------------------------------------------------------------------------
 */
"use client";
import { Spreadsheet as r, toolsValueMap as t } from "./Spreadsheet.mjs";
import { CalcError as m, CellRef as n, Context as l, Matrix as p, NULLREF as f, NameRef as i, Range as x, RangeRef as d, Ref as c, Sheet as R, SpreadsheetWidget as s, UnionRef as g, View as u, Workbook as A, dateToSerial as C, defineAlias as D, defineFunction as F, packDate as k, packTime as S, serialToDate as T, unpackDate as w, unpackTime as h } from "@progress/kendo-spreadsheet-common";
import { DecreaseDecimal as E, IncreaseDecimal as L } from "./tools/adjustDecimals.mjs";
import { AlignHorizontally as b, AlignVertically as y, Alignment as B } from "./tools/align.mjs";
import { BackgroundColor as V } from "./tools/backgroundColor.mjs";
import { Bold as M } from "./tools/bold.mjs";
import { defaultTabs as v } from "./tools/defaultTools.mjs";
import { ExcelExport as H } from "./tools/export.mjs";
import { FontFamily as j } from "./tools/fontFamily.mjs";
import { DecreaseFontSize as J, FontSize as K, IncreaseFontSize as P } from "./tools/fontSize.mjs";
import { CleanFormatting as X } from "./tools/cleanFormat.mjs";
import { Format as Z } from "./tools/format.mjs";
import { GridLines as $ } from "./tools/gridLines.mjs";
import { Italic as oe } from "./tools/italic.mjs";
import { Open as te } from "./tools/open.mjs";
import { Redo as me } from "./tools/redo.mjs";
import { AddColumnLeft as le, AddColumnRight as pe, AddRowAbove as fe, AddRowBelow as ie, DeleteColumn as xe, DeleteRow as de } from "./tools/tableTools.mjs";
import { TextColor as Re } from "./tools/textColor.mjs";
import { TextWrap as ge } from "./tools/textWrap.mjs";
import { Underline as Ae } from "./tools/underline.mjs";
import { Undo as De } from "./tools/undo.mjs";
export {
  le as AddColumnLeft,
  pe as AddColumnRight,
  fe as AddRowAbove,
  ie as AddRowBelow,
  b as AlignHorizontally,
  y as AlignVertically,
  B as Alignment,
  V as BackgroundColor,
  M as Bold,
  m as CalcError,
  n as CellRef,
  X as CleanFormatting,
  l as Context,
  E as DecreaseDecimal,
  J as DecreaseFontSize,
  xe as DeleteColumn,
  de as DeleteRow,
  H as ExcelExport,
  j as FontFamily,
  K as FontSize,
  Z as Format,
  $ as GridLines,
  L as IncreaseDecimal,
  P as IncreaseFontSize,
  oe as Italic,
  p as Matrix,
  f as NULLREF,
  i as NameRef,
  te as Open,
  x as Range,
  d as RangeRef,
  me as Redo,
  c as Ref,
  R as Sheet,
  r as Spreadsheet,
  s as SpreadsheetWidget,
  Re as TextColor,
  ge as TextWrap,
  Ae as Underline,
  De as Undo,
  g as UnionRef,
  u as View,
  A as Workbook,
  C as dateToSerial,
  v as defaultTabs,
  D as defineAlias,
  F as defineFunction,
  k as packDate,
  S as packTime,
  T as serialToDate,
  t as toolsValueMap,
  w as unpackDate,
  h as unpackTime
};
