/**
 * @license
 *-------------------------------------------------------------------------------------------
 * Copyright © 2025 Progress Software Corporation. All rights reserved.
 * Licensed under commercial license. See LICENSE.md in the package root for more information
 *-------------------------------------------------------------------------------------------
 */
import { ToolbarSeparator as o } from "@progress/kendo-react-buttons";
import { ExcelExport as t } from "./export.mjs";
import { Open as e } from "./open.mjs";
import { Bold as m } from "./bold.mjs";
import { Italic as i } from "./italic.mjs";
import { Underline as l } from "./underline.mjs";
import { FontFamily as p } from "./fontFamily.mjs";
import { FontSize as f, IncreaseFontSize as a, DecreaseFontSize as n } from "./fontSize.mjs";
import { TextColor as d } from "./textColor.mjs";
import { BackgroundColor as s } from "./backgroundColor.mjs";
import { AlignHorizontally as c, AlignVertically as x } from "./align.mjs";
import { TextWrap as y } from "./textWrap.mjs";
import { GridLines as A } from "./gridLines.mjs";
import { Format as u } from "./format.mjs";
import { AddColumnLeft as D, AddColumnRight as F, AddRowBelow as C, AddRowAbove as R, DeleteColumn as T, DeleteRow as b } from "./tableTools.mjs";
import { keys as r } from "../messages.mjs";
import { Undo as g } from "./undo.mjs";
import { Redo as w } from "./redo.mjs";
import { DecreaseDecimal as z, IncreaseDecimal as K } from "./adjustDecimals.mjs";
const P = [
  {
    textKey: r.file,
    tools: [e, t]
  },
  {
    textKey: r.home,
    selected: !0,
    tools: [
      [g, w],
      o,
      p,
      f,
      a,
      n,
      o,
      [m, i, l],
      d,
      o,
      s,
      o,
      c,
      x,
      y,
      o,
      A
    ]
  },
  {
    textKey: r.insert,
    tools: [[D, F, C, R], o, [T, b]]
  },
  {
    textKey: r.formatTab,
    tools: [u, [z, K]]
  }
];
export {
  P as defaultTabs
};
