/**
 * @license
 *-------------------------------------------------------------------------------------------
 * Copyright © 2025 Progress Software Corporation. All rights reserved.
 * Licensed under commercial license. See LICENSE.md in the package root for more information
 *-------------------------------------------------------------------------------------------
 */
"use strict";Object.defineProperty(exports,Symbol.toStringTag,{value:"Module"});const ee=require("react"),s=require("prop-types"),S=require("@progress/kendo-react-buttons"),z=require("@progress/kendo-react-layout"),P=require("@progress/kendo-react-dialogs"),M=require("./FormulaInput.js"),te=require("./NameBox.js"),re=require("./SheetsBar.js"),ne=require("@progress/kendo-spreadsheet-common"),W=require("./tools/defaultTools.js"),y=require("@progress/kendo-react-common"),oe=require("./package-metadata.js"),ae=require("@progress/kendo-svg-icons"),C=require("@progress/kendo-react-intl"),se=require("@progress/kendo-file-saver"),le=require("@progress/kendo-ooxml"),l=require("./messages.js");function ce(e){const g=Object.create(null,{[Symbol.toStringTag]:{value:"Module"}});if(e){for(const m in e)if(m!=="default"){const f=Object.getOwnPropertyDescriptor(e,m);Object.defineProperty(g,m,f.get?f:{enumerable:!0,get:()=>e[m]})}}return g.default=e,Object.freeze(g)}const r=ce(ee),j=["bold","italic","underline","fontFamily","fontSize","color","background","textAlign","verticalAlign","wrap","gridLines"],w={Bold:e=>e.bold,Italic:e=>e.italic,Underline:e=>e.underline,FontFamily:e=>e.fontFamily,FontSize:e=>e.fontSize,IncreaseFontSize:e=>e.fontSize,DecreaseFontSize:e=>e.fontSize,TextColor:e=>e.color,BackgroundColor:e=>e.background,Alignment:e=>({textAlign:e.textAlign,verticalAlign:e.verticalAlign}),AlignHorizontally:e=>e.textAlign,AlignVertically:e=>e.verticalAlign,TextWrap:e=>e.wrap,GridLines:e=>e.gridLines,AddColumnLeft:e=>e.selectedHeaders,AddColumnRight:e=>e.selectedHeaders,AddRowBelow:e=>e.selectedHeaders,AddRowAbove:e=>e.selectedHeaders,DeleteColumn:e=>e.selectedHeaders,DeleteRow:e=>e.selectedHeaders},D=":not(.k-dropdownlist button):not(.k-combobox button):not(.k-upload-button):not(.k-colorpicker button):not(.k-split-button .k-split-button-arrow)",ue=["button"+D,".k-button-group > button"+D,".k-dropdownlist",".k-combobox",".k-colorpicker"],N=r.forwardRef((e,g)=>{const m=!y.validatePackage(oe.packageMetadata,{component:"Spreadsheet"}),{toolbar:f=W.defaultTabs}=e,p=[];typeof f=="boolean"?p.push(...f?W.defaultTabs:[]):p.push(...f);const[u,R]=r.useState(null),[J,K]=r.useState(p.findIndex(t=>t.selected)||0),[ie,_]=r.useState(!1),v=r.useRef(null),I=r.useRef(null),A=r.useRef(null),F=r.useRef(null),a=r.useRef(null),[E,G]=r.useState({}),h=r.useRef({});h.current=E;const c=r.useRef({});c.current=e;const x=C.useLocalization(),V=r.useCallback(t=>{c.current.onSelect&&c.current.onSelect.call(void 0,t)},[]),U=r.useCallback(t=>{c.current.onChange&&c.current.onChange.call(void 0,t)},[]),Q=r.useCallback(t=>{c.current.onChangeFormat&&c.current.onChangeFormat.call(void 0,t)},[]),X=r.useCallback(t=>{c.current.onExcelImport&&c.current.onExcelImport.call(void 0,t)},[]),Y=r.useCallback(t=>{c.current.onExcelExport&&c.current.onExcelExport.call(void 0,t)},[]),q=r.useRef(null);r.useImperativeHandle(q,()=>({element:v.current,get instance(){return a.current},props:e,get view(){return a.current.view},get workbook(){return a.current.workbook},executeCommand(t){var n;(n=a.current)==null||n.executeCommand(t)},fromJSON(t){var n;return(n=a.current)==null?void 0:n.fromJSON(t)},toJSON(){return a.current.toJSON()},saveJSON(){return a.current.saveJSON()},fromFile(t){return a.current.fromFile(t)},saveAsExcel(t){var n;(n=a.current)==null||n.saveAsExcel({...a.current.options.excel,saveAs:se.saveAs,Workbook:le.Workbook,...t})},activeSheet(t){var n;return(n=a.current)==null?void 0:n.activeSheet(t)},sheets(){return a.current.sheets()},refresh(){var t;return(t=a.current)==null?void 0:t.refresh()}}),[e]),r.useImperativeHandle(g,()=>q.current);const Z=r.useCallback(()=>a.current&&a.current.view.nameEditor,[]),T=r.useCallback(t=>{const n={};j.forEach(o=>{typeof t.range[o]=="function"?n[o]=t.range[o]():o==="gridLines"&&(n[o]=t.range.sheet().showGridLines())}),n.selectedHeaders=t.range.sheet().selectedHeaders(),(j.some(o=>n[o]!==h.current[o])||n.selectedHeaders.allCols!==h.current.selectedHeaders.allCols||n.selectedHeaders.allRows!==h.current.selectedHeaders.allRows)&&G(n)},[]),$=r.useCallback(t=>{const n=t.name,o=l.keys[n];R({title:t.title==="Error"?x.toLanguageString(l.keys.error,l.messages[l.keys.error]):t.title,message:o?x.toLanguageString(o,l.messages[o]||t.text):t.text,close:t.close})},[]),H=r.useCallback(()=>{R(null),u==null||u.close()},[u]),k=C.useInternationalization(),O=C.useLocalization();r.useEffect(()=>{var b;const t={...e.defaultProps,sheets:window==null?void 0:window.structuredClone((b=e.defaultProps)==null?void 0:b.sheets),messages:{workbook:{defaultSheetName:O.toLanguageString(l.keys.defaultSheetName,l.messages[l.keys.defaultSheetName])}},intl:{localeInfo:()=>k.localeInfo(),localeCurrency:()=>k.localeCurrency(),parseDate:(i,d)=>k.parseDate(i,d),toString:(i,d)=>k.toString(i,d),format:(i,...d)=>k.format(i,...d)},formulaBarInputRef:I,formulaCellInputRef:A,nameBoxRef:F},n=new ne.SpreadsheetWidget(v.current,t);a.current=n,n.bind("select",V),n.bind("change",U),n.bind("changeFormat",Q),n.bind("excelImport",X),n.bind("excelExport",Y),n.view.bind("update",T),n.view.bind("message",$);const o=n.activeSheet();return o&&T({range:o.range(o.activeCell())}),_(!0),()=>{n.destroy()}},[]);const B=r.useCallback((t,n)=>{const o=r.createElement(t,{spreadsheetRef:a,value:w[t.displayName]?w[t.displayName](E):void 0,key:n});return o.type===S.ToolbarSeparator?r.createElement(t,{key:n}):o},[E]);let L=null;return p.length&&(L=r.createElement(z.TabStrip,{selected:J,animation:!1,className:"k-floatwrap k-spreadsheet-tabstrip",style:{minHeight:"auto"},onSelect:t=>K(t.selected)},p.map(t=>{const n=t.textKey?O.toLanguageString(t.textKey,l.messages[t.textKey]):t.text;return r.createElement(z.TabStripTab,{key:t.textKey||t.text,title:n},r.createElement(S.Toolbar,{buttons:ue,className:"k-spreadsheet-toolbar"},t.tools.map((o,b)=>Array.isArray(o)?r.createElement(S.ButtonGroup,{key:b},o.map((i,d)=>B(i,d))):B(o,b))))}))),r.createElement("div",{ref:v,style:e.style,className:y.classNames("k-widget k-spreadsheet",e.className),role:"application"},L,r.createElement("div",{className:"k-spreadsheet-action-bar"},r.createElement(te.NameBox,{ref:F,nameEditor:Z}),r.createElement("div",{className:"k-spreadsheet-formula-bar"},r.createElement(y.IconWrap,{name:"formula-fx",icon:ae.formulaFxIcon}),r.createElement(M.FormulaInput,{ref:I}))),r.createElement("div",{className:"k-spreadsheet-view"},r.createElement("div",{className:"k-spreadsheet-fixed-container"}),r.createElement("div",{className:"k-spreadsheet-scroller"},r.createElement("div",{className:"k-spreadsheet-view-size"})),r.createElement("div",{tabIndex:0,className:"k-spreadsheet-clipboard",contentEditable:"true"}),r.createElement(M.FormulaInput,{ref:A,className:"k-spreadsheet-cell-editor"})),r.createElement(re.SheetsBar,{spreadsheetRef:a}),u&&r.createElement(P.Dialog,{title:u.title,onClose:H},r.createElement("div",null,u.message),r.createElement(P.DialogActionsBar,{layout:"start"},r.createElement(S.Button,{themeColor:"primary",onClick:H,autoFocus:!0},x.toLanguageString(l.keys.ok,l.messages[l.keys.ok])))),m&&r.createElement(y.WatermarkOverlay,null))});N.displayName="KendoReactSpreadsheet";N.propTypes={className:s.string,defaultProps:s.any,toolbar:s.oneOfType([s.bool,s.arrayOf(s.any)]),style:s.object,onSelect:s.func,onChange:s.func,onChangeFormat:s.func,onExcelImport:s.func,onExcelExport:s.func};exports.Spreadsheet=N;exports.toolsValueMap=w;
